// test.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <windows.h>
#include <shellapi.h>
#pragma comment(lib, "shell32.lib")

#include "mini2.h"

LPlayerControl g_LPlayerControl;
IPlayerControl* g_MiniPlayer = NULL;


#define WND_CLASSNAME "MINIPLAYER2TEST"

HWND g_hWnd;
HINSTANCE g_hInstance;
BOOL g_isProgramLooping = FALSE;
bool g_bPlaying = false;

LRESULT CALLBACK WindowProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

BOOL RegisterWindowClass ()												
{																		
	// Register A Window Class
	WNDCLASSEX windowClass;												// Window Class
	ZeroMemory (&windowClass, sizeof (WNDCLASSEX));						// Make Sure Memory Is Cleared
	windowClass.cbSize			= sizeof (WNDCLASSEX);					// Size Of The windowClass Structure
	windowClass.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraws The Window For Any Movement / Resizing
	windowClass.lpfnWndProc		= (WNDPROC)(WindowProc);				// WindowProc Handles Messages
	windowClass.hInstance		= g_hInstance;							// Set The Instance
	windowClass.hbrBackground	= (HBRUSH)(BLACK_BRUSH);				// Class Background Brush Color
	windowClass.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	windowClass.lpszClassName	= WND_CLASSNAME;						// Sets The Applications Classname
	if (RegisterClassEx (&windowClass) == 0)							// Did Registering The Class Fail?
	{
		// NOTE: Failure, Should Never Happen
		MessageBox (HWND_DESKTOP, "RegisterClassEx Failed!", "Error", MB_OK | MB_ICONEXCLAMATION);
		return FALSE;													// Return False (Failure)
	}
	return TRUE;														// Return True (Success)
}



LRESULT CALLBACK WindowProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)														// Evaluate Window Message
	{
	case WM_DROPFILES:	// Allow to darg'n'drop any file on player window 
		{
			if (g_MiniPlayer!=NULL)
			{
				HDROP drop;
				char filename[MAX_PATH];
				int count;
				
				drop=(HDROP)wParam;
				count = DragQueryFile(drop, 0xffffffff, NULL, 0);
				
				//for (i=0; i<count; i++)
				{
					DragQueryFile(drop, 0, filename, 256);
					g_MiniPlayer->Stop();
					g_bPlaying = false;
					g_LPlayerControl.DeletePlayerControl(g_MiniPlayer);

					g_MiniPlayer = g_LPlayerControl.NewPlayerControl();
					if (g_MiniPlayer!=NULL)
					{
						g_MiniPlayer->SetWindowHandle(hWnd);
						g_MiniPlayer->SetFileName(filename);
						g_MiniPlayer->Play();
						InvalidateRect(hWnd, NULL, TRUE);
						g_bPlaying = true;
					}
				}
			}
			
			return 0;
			break;
		}
		
	case WM_SYSCOMMAND: // block screensavers and monitor power-off
		{
			switch (wParam)											
			{
			case SC_SCREENSAVE:										
			case SC_MONITORPOWER:									
				return 0;											
			}
			break;													
		}
		return 0;													
		
	case WM_CREATE:													
		{
			g_MiniPlayer = g_LPlayerControl.NewPlayerControl();
			if (g_MiniPlayer!=NULL)
				g_MiniPlayer->SetWindowHandle(hWnd);
		}
		return 0;														
		
	case WM_CLOSE:													
		PostMessage (hWnd, WM_QUIT, 0, 0);							
		g_isProgramLooping = FALSE;									
		if (g_MiniPlayer!=NULL)
		{
			g_MiniPlayer->Stop();
			g_bPlaying = true;
			g_LPlayerControl.DeletePlayerControl(g_MiniPlayer);
			g_MiniPlayer = NULL;
		}
		return 0;													
		
	case WM_ERASEBKGND:	// a trick.. if player is not playing... allow background erase
		if (g_bPlaying)	return 0;
		else break;
		
	case WM_SIZING: // update video size during sizing or size events
	case WM_SIZE:													
		if (g_MiniPlayer!=NULL)
			g_MiniPlayer->Resize();		
		return 0;
		break;															
	}
	
	return DefWindowProc (hWnd, uMsg, wParam, lParam);	// Pass Unhandled Messages To DefWindowProc
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	g_hInstance = hInstance;
	RegisterWindowClass();
	
	g_hWnd = CreateWindowEx (WS_EX_APPWINDOW,					// Extended Style
		WND_CLASSNAME,											// Class Name
		"MiniPlayer2 Test",										// Window Title
		WS_OVERLAPPEDWINDOW,									// Window Style
		50, 50, 800, 600,
		HWND_DESKTOP,											// Desktop Is Window's Parent
		0,														// No Menu
		g_hInstance,											// Pass The Window Instance
		NULL);
	
	ShowWindow (g_hWnd, SW_NORMAL);								// Make The Window Visible
	DragAcceptFiles(g_hWnd, TRUE);								// Allow drag'n'drop on this window

	g_isProgramLooping = true;
	MSG msg;
	while (g_isProgramLooping)									// Loop Until WM_QUIT Is Received
	{
		while (GetMessage (&msg, g_hWnd, 0, 0))
		{
			TranslateMessage (&msg) ;
			DispatchMessage (&msg) ;
		}
	}
	
	return 0;
}



